Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 21)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 56)
@@ -2288,14 +893,8 @@
  * \param width the width of the block
  * \param height the height of the block
- * \param blkAboveAvailable boolean indication if the block above is available
- * \param blkLeftAvailable boolean indication if the block to the left is available
  *
  * This function derives the prediction samples for planar mode (intra coding).
  */
-#if REFERENCE_SAMPLE_PADDING
-Void TComPrediction::xPredIntraPlanar( Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, UInt width, UInt height )
-#else
-Void TComPrediction::xPredIntraPlanar( Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, UInt width, UInt height, Bool blkAboveAvailable, Bool blkLeftAvailable )
-#endif
+Void TComPrediction::xPredIntraPlanar( Int* pSrc, Int srcStride, Pel* rpDst, Int dstStride, UInt width, UInt height )
 {
   assert(width == height);
@@ -2310,56 +909,13 @@
 
   // Get left and above reference column and row
-#if REFERENCE_SAMPLE_PADDING
-  for(k=0;k<blkSize;k++)
+  for(k=0;k<blkSize+1;k++)
   {
     topRow[k] = pSrc[k-srcStride];
     leftColumn[k] = pSrc[k*srcStride-1];
   }
-#else
-  if (!blkAboveAvailable && !blkLeftAvailable)
-  {
-    for(k=0;k<blkSize;k++)
-    {
-      leftColumn[k] = topRow[k] = ( 1 << ( g_uiBitDepth + g_uiBitIncrement - 1 ) );
-    }
-  }
-  else
-  {
-    if(blkAboveAvailable)
-    {
-      for(k=0;k<blkSize;k++)
-      {
-        topRow[k] = pSrc[k-srcStride];
-      }
-    }
-    else
-    {
-      Int leftSample = pSrc[-1];
-      for(k=0;k<blkSize;k++)
-      {
-        topRow[k] = leftSample;
-      }
-    }
-    if(blkLeftAvailable)
-    {
-      for(k=0;k<blkSize;k++)
-      {
-        leftColumn[k] = pSrc[k*srcStride-1];
-      }
-    }
-    else
-    {
-      Int aboveSample = pSrc[-srcStride];
-      for(k=0;k<blkSize;k++)
-      {
-        leftColumn[k] = aboveSample;
-      }
-    }
-  }
-#endif
 
   // Prepare intermediate variables used in interpolation
-  bottomLeft = leftColumn[blkSize-1];
-  topRight   = topRow[blkSize-1];
+  bottomLeft = leftColumn[blkSize];
+  topRight   = topRow[blkSize];
   for (k=0;k<blkSize;k++)
   {
@@ -2382,10 +938,8 @@
   }
 }
-#endif
-
-#if LM_CHROMA
+
 /** Function for deriving chroma LM intra prediction.
  * \param pcPattern pointer to neighbouring pixel access pattern
- * \param pSrc pointer to reconstructed chroma sample array
+ * \param piSrc pointer to reconstructed chroma sample array
  * \param pPred pointer for the prediction sample array
  * \param uiPredStride the stride of the prediction sample array
@@ -2393,14 +947,10 @@
  * \param uiCHeight the height of the chroma block
  * \param uiChromaId boolean indication of chroma component
-
- \ This function derives the prediction samples for chroma LM mode (chroma intra coding)
+ *
+ * This function derives the prediction samples for chroma LM mode (chroma intra coding)
  */
 Void TComPrediction::predLMIntraChroma( TComPattern* pcPattern, Int* piSrc, Pel* pPred, UInt uiPredStride, UInt uiCWidth, UInt uiCHeight, UInt uiChromaId )
 {
-  UInt uiWidth  = uiCWidth << 1;
-  UInt uiHeight = uiCHeight << 1;
-
-  if (uiChromaId == 0)
-    xGetRecPixels( pcPattern, pcPattern->getROIY(), pcPattern->getPatternLStride(), m_pLumaRecBuffer + m_iLumaRecStride + 1, m_iLumaRecStride, uiWidth, uiHeight );
+  UInt uiWidth  = 2 * uiCWidth;
 
   xGetLLSPrediction( pcPattern, piSrc+uiWidth+2, uiWidth+1, pPred, uiPredStride, uiCWidth, uiCHeight, 1 );  
@@ -2409,55 +959,69 @@
 /** Function for deriving downsampled luma sample of current chroma block and its above, left causal pixel
  * \param pcPattern pointer to neighbouring pixel access pattern
- * \param pRecSrc pointer to reconstructed luma sample array
- * \param iRecSrcStride the stride of reconstructed luma sample array
- * \param pDst0 pointer to downsampled luma sample array
- * \param iDstStride the stride of downsampled luma sample array
- * \param uiWidth0 the width of the luma block
- * \param uiHeight0 the height of the luma block
-
- \ This function derives downsampled luma sample of current chroma block and its above, left causal pixel
+ * \param uiCWidth the width of the chroma block
+ * \param uiCHeight the height of the chroma block
+ *
+ * This function derives downsampled luma sample of current chroma block and its above, left causal pixel
  */
-
-Void TComPrediction::xGetRecPixels( TComPattern* pcPattern, Pel* pRecSrc, Int iRecSrcStride, Pel* pDst0, Int iDstStride, UInt uiWidth0, UInt uiHeight0 )
-{
-  Pel* pSrc = pRecSrc;
-  Pel* pDst = pDst0;
-
-  Int uiCWidth = uiWidth0/2;
-  Int uiCHeight = uiHeight0/2;
-
-  if( pcPattern->isLeftAvailable() )
-  {
-    pSrc = pSrc - 2;
-    pDst = pDst - 1;
-
-    uiCWidth += 1;
-  }
-
-  if( pcPattern->isAboveAvailable() )
-  {
-    pSrc = pSrc - 2*iRecSrcStride;
-    pDst = pDst - iDstStride;
-
-    uiCHeight += 1;
-  }
-
+Void TComPrediction::getLumaRecPixels( TComPattern* pcPattern, UInt uiCWidth, UInt uiCHeight )
+{
+  UInt uiWidth  = 2 * uiCWidth;
+  UInt uiHeight = 2 * uiCHeight;  
+
+  Pel* pRecSrc = pcPattern->getROIY();
+  Pel* pDst0 = m_pLumaRecBuffer + m_iLumaRecStride + 1;
+
+  Int iRecSrcStride = pcPattern->getPatternLStride();
+  Int iRecSrcStride2 = iRecSrcStride << 1;
+  Int iDstStride = m_iLumaRecStride;
+  Int iSrcStride = ( max( uiWidth, uiHeight ) << 1 ) + 1;
+
+  Int* ptrSrc = pcPattern->getAdiOrgBuf( uiWidth, uiHeight, m_piYuvExt );
+
+  // initial pointers
+  Pel* pDst = pDst0 - 1 - iDstStride;  
+  Int* piSrc = ptrSrc;
+
+  // top left corner downsampled from ADI buffer
+  // don't need this point
+
+  // top row downsampled from ADI buffer
+  pDst++;     
+  piSrc ++;
+  for (Int i = 0; i < uiCWidth; i++)
+  {
+    pDst[i] = ((piSrc[2*i] * 2 ) + piSrc[2*i - 1] + piSrc[2*i + 1] + 2) >> 2;
+  }
+
+  // left column downsampled from ADI buffer
+  pDst = pDst0 - 1; 
+  piSrc = ptrSrc + iSrcStride;
+  for (Int j = 0; j < uiCHeight; j++)
+  {
+    pDst[0] = ( piSrc[0] + piSrc[iSrcStride] ) >> 1;
+    piSrc += iSrcStride << 1; 
+    pDst += iDstStride;    
+  }
+
+  // inner part from reconstructed picture buffer
   for( Int j = 0; j < uiCHeight; j++ )
-    {
-      for( Int i = 0, ii = i << 1; i < uiCWidth; i++, ii = i << 1 )
-        pDst[i] = (pSrc[ii] + pSrc[ii + iRecSrcStride]) >> 1;
-
-      pDst += iDstStride;
-      pSrc += iRecSrcStride*2;
-    }  
+  {
+    for (Int i = 0; i < uiCWidth; i++)
+    {
+      pDst0[i] = (pRecSrc[2*i] + pRecSrc[2*i + iRecSrcStride]) >> 1;
+    }
+
+    pDst0 += iDstStride;
+    pRecSrc += iRecSrcStride2;
+  }
 }
 
 /** Function for deriving the positon of first non-zero binary bit of a value
  * \param x input value
- \ This function derives the positon of first non-zero binary bit of a value
+ *
+ * This function derives the positon of first non-zero binary bit of a value
  */
 Int GetMSB( UInt x )
 {
-#if 1
   Int iMSB = 0, bits = ( sizeof( Int ) << 3 ), y = 1;
 
@@ -2476,15 +1040,47 @@
   iMSB+=y;
 
-#else
-
-  Int iMSB = 0;
-  while( x > 0 )
-  {
-    x >>= 1;
-    iMSB++;
-  }
-#endif
-
   return iMSB;
+}
+
+/** Function for counting leading number of zeros/ones
+ * \param x input value
+ \ This function counts leading number of zeros for positive numbers and
+ \ leading number of ones for negative numbers. This can be implemented in
+ \ single instructure cycle on many processors.
+ */
+
+Short CountLeadingZerosOnes (Short x)
+{
+  Short clz;
+  Short i;
+
+  if(x == 0)
+  {
+    clz = 0;
+  }
+  else
+  {
+    if (x == -1)
+    {
+      clz = 15;
+    }
+    else
+    {
+      if(x < 0)
+      {
+        x = ~x;
+      }
+      clz = 15;
+      for(i = 0;i < 15;++i)
+      {
+        if(x) 
+        {
+          clz --;
+        }
+        x = x >> 1;
+      }
+    }
+  }
+  return clz;
 }
 
@@ -2498,6 +1094,6 @@
  * \param uiHeight the height of the chroma block
  * \param uiExt0 line number of neiggboirng pixels for calculating LM model parameter, default value is 1
-
- \ This function derives the prediction samples for chroma LM mode (chroma intra coding)
+ *
+ * This function derives the prediction samples for chroma LM mode (chroma intra coding)
  */
 Void TComPrediction::xGetLLSPrediction( TComPattern* pcPattern, Int* pSrc0, Int iSrcStride, Pel* pDst0, Int iDstStride, UInt uiWidth, UInt uiHeight, UInt uiExt0 )
@@ -2518,39 +1114,32 @@
   Int x = 0, y = 0, xx = 0, xy = 0;
 
-  if( pcPattern->isAboveAvailable() )
-  {
-    pSrc  = pSrc0  - iSrcStride;
-    pLuma = pLuma0 - iLumaStride;
-
-    for( j = 0; j < uiWidth; j++ )
-    {
-      x += pLuma[j];
-      y += pSrc[j];
-      xx += pLuma[j] * pLuma[j];
-      xy += pLuma[j] * pSrc[j];
-    }
-    iCountShift += g_aucConvertToBit[ uiWidth ] + 2;
-  }
-
-  if( pcPattern->isLeftAvailable() )
-  {
-    pSrc  = pSrc0 - uiExt;
-    pLuma = pLuma0 - uiExt;
-
-    for( i = 0; i < uiHeight; i++ )
-    {
-      x += pLuma[0];
-      y += pSrc[0];
-      xx += pLuma[0] * pLuma[0];
-      xy += pLuma[0] * pSrc[0];
-
-      pSrc  += iSrcStride;
-      pLuma += iLumaStride;
-    }
-    iCountShift += iCountShift > 0 ? 1 : ( g_aucConvertToBit[ uiWidth ] + 2 );
-  }
-
-  Int iBitdepth = ( ( g_uiBitDepth + g_uiBitIncrement ) + g_aucConvertToBit[ uiWidth ] + 3 ) * 2;
-  Int iTempShift = Max( ( iBitdepth - 31 + 1) / 2, 0);
+  pSrc  = pSrc0  - iSrcStride;
+  pLuma = pLuma0 - iLumaStride;
+
+  for( j = 0; j < uiWidth; j++ )
+  {
+    x += pLuma[j];
+    y += pSrc[j];
+    xx += pLuma[j] * pLuma[j];
+    xy += pLuma[j] * pSrc[j];
+  }
+  iCountShift += g_aucConvertToBit[ uiWidth ] + 2;
+
+  pSrc  = pSrc0 - uiExt;
+  pLuma = pLuma0 - uiExt;
+
+  for( i = 0; i < uiHeight; i++ )
+  {
+    x += pLuma[0];
+    y += pSrc[0];
+    xx += pLuma[0] * pLuma[0];
+    xy += pLuma[0] * pSrc[0];
+
+    pSrc  += iSrcStride;
+    pLuma += iLumaStride;
+  }
+  iCountShift += iCountShift > 0 ? 1 : ( g_aucConvertToBit[ uiWidth ] + 2 );
+
+  Int iTempShift = ( g_uiBitDepth + g_uiBitIncrement ) + g_aucConvertToBit[ uiWidth ] + 3 - 15;
 
   if(iTempShift > 0)
@@ -2568,5 +1157,5 @@
   {
     a = 0;
-    b = 128 << g_uiBitIncrement;
+    b = 1 << (g_uiBitDepth + g_uiBitIncrement - 1);
     iShift = 0;
   }
@@ -2576,11 +1165,4 @@
     Int a2 = ( xx << iCountShift ) - x * x;              
 
-    if( a2 == 0 || a1 == 0 )
-    {
-      a = 0;
-      b = ( y + ( 1 << ( iCountShift - 1 ) ) )>> iCountShift;
-      iShift = 0;
-    }
-    else
     {
       const Int iShiftA2 = 6;
@@ -2597,9 +1179,13 @@
 
       if( iScaleShiftA1 < 0 )
+      {
         iScaleShiftA1 = 0;
-
+      }
+      
       if( iScaleShiftA2 < 0 )
+      {
         iScaleShiftA2 = 0;
-
+      }
+      
       Int iScaleShiftA = iScaleShiftA2 + iAccuracyShift - iShift - iScaleShiftA1;
 
@@ -2608,15 +1194,36 @@
       a1s = a1 >> iScaleShiftA1;
 
-      a = a1s * m_uiaShift[ abs( a2s ) ];
+      if (a2s >= 1)
+      {
+        a = a1s * m_uiaShift[ a2s - 1];
+      }
+      else
+      {
+        a = 0;
+      }
       
       if( iScaleShiftA < 0 )
+      {
         a = a << -iScaleShiftA;
+      }
       else
+      {
         a = a >> iScaleShiftA;
-
-      if( a > ( 1 << 15 ) - 1 )
-        a = ( 1 << 15 ) - 1;
-      else if( a < -( 1 << 15 ) )
-        a = -( 1 << 15 );
+      }
+      
+       a = Clip3(-( 1 << 15 ), ( 1 << 15 ) - 1, a); 
+     
+      Int minA = -(1 << (6));
+      Int maxA = (1 << 6) - 1;
+      if( a <= maxA && a >= minA )
+      {
+        // do nothing
+      }
+      else
+      {
+        Short n = CountLeadingZerosOnes(a);
+        a = a >> (9-n);
+        iShift -= (9-n);
+      }
 
       b = (  y - ( ( a * x ) >> iShift ) + ( 1 << ( iCountShift - 1 ) ) ) >> iCountShift;
@@ -2634,6 +1241,8 @@
   {
     for( j = 0; j < uiWidth; j++ )
+    {
       pDst[j] = Clip( ( ( a * pLuma[j] ) >> iShift ) + b );
-
+    }
+    
     pDst  += iDstStride;
     pLuma += iLumaStride;
@@ -2642,7 +1251,5 @@
 
 }
-#endif
-
-#if MN_DC_PRED_FILTER
+
 /** Function for filtering intra DC predictor.
  * \param pSrc pointer to reconstructed sample array
